﻿#include <iostream>
#include "part1.h"
#include "part2.h"
#include <vector>
#include <list>
#include <deque>
//тут раскомментировать одну строку из двух с нужной частью дз 
//#define HW_PART_1
#define HW_PART_2

#ifdef HW_PART_1
template < typename T >
void main_menu(T& container)
{
	std::string fileName("file.txt");
	std::string fileNameOut("file_out.txt");
	bool is_running = true;
	int option;

	while (is_running)
	{
		std::cout << std::endl << "Choose func:" << std::endl
			<< "1)createDataStream" << std::endl
			<< "2)createDataIterator" << std::endl
			<< "3)loadDataStream" << std::endl
			<< "4)loadDataIterator" << std::endl
			<< "5)printContainer" << std::endl
			<< "6)ModifyContainer" << std::endl
			<< "7)ModifyContainerIterators" << std::endl
			<< "8)ModifyContainerForEach" << std::endl
			<< "9)ModifyContainerTransform" << std::endl
			<< "10)outputResultStream" << std::endl
			<< "11)outputResultCopy" << std::endl
			<< "12)Choose other container" << std::endl << "->  ";

		std::cin >> option;

		std::cout << std::endl;
		try {
			switch (option)
			{
			case 1:
				createDataStream(fileName);
				break;
			case 2:
				createDataIterator(fileName);
				break;
			case 3:
				container = std::move(loadDataStream<T>(fileName));
				break;
			case 4:
				container = std::move(loadDataIterator<T>(fileName));
				break;
			case 5:
				printContainer(container);
				break;
			case 6:
				ModifyContainer(container);
				break;
			case 7:
				ModifyContainerIterators(container.begin(), container.end());
				break;
			case 8:
				ModifyContainerForEach(container);
				break;
			case 9:
				ModifyContainerTransform(fileName, fileNameOut);
				break;
			case 10:
				outputResultStream(container, fileNameOut);
				break;
			case 11:
				outputResultCopy(container, fileNameOut);
				break;
			case 12:
				is_running = false;
				break;
			default:
				std::cout << "Wrong input" << std::endl;
				break;
			}
		}
		catch (std::exception& e)
		{
			std::cout << "Exception: " << e.what() << std::endl;
		}

	}
}

int run()
{
	bool is_running = true;
	int option;

	while (is_running)
	{
		std::cout << std::endl << "Choose container:" << std::endl
			<< "1)Vector" << std::endl
			<< "2)List" << std::endl
			<< "3)Deque" << std::endl
			<< "4)Exit" << std::endl << "->  ";

		std::cin >> option;

		std::cout << std::endl;
		std::deque<int> deq;
		std::list<int> lst;
		std::vector<int> vec;
		switch (option)
		{
		case 1:
			main_menu(deq);
			deq.clear();
			break;
		case 2:
			main_menu(lst);
			lst.clear();
			break;
		case 3:
			main_menu(vec);
			vec.clear();
			break;
		case 4:
			is_running = false;
			break;
		default:
			std::cout << "invalid option" << std::endl;
			break;
		}

	}
	return 1;
}

int main()
{
	run();
	return 0;
}
#endif // HW_PART_1

#ifdef HW_PART_2
int main()
{
	general D;
	account acc1, acc2;
	int temp_int;
	std::string temp_str;
	bool is_running = true;
	int k;

	while (is_running)
	{
		std::cout << std::endl << "1 add payment" << std::endl
			<< "2 search account by a number" << std::endl
			<< "3 search account by code" << std::endl
			<< "4 search account by an owner's surname" << std::endl
			<< "5 search account by full info" << std::endl
			<< "6 delete account" << std::endl
			<< "7 change account" << std::endl
			<< "8 load to txt file" << std::endl
			<< "9 exit" << std::endl << "->  ";

		std::cin >> k;

		std::cout << std::endl;

		switch (k)
		{
		case 1:
			std::cout << "Input account to add" << std::endl;
			std::cin >> acc1;
			D.add_account(acc1);
			break;
		case 2:
			std::cout << "Input account number to search" << std::endl;
			std::cin >> temp_int;
			D.search_account_number(temp_int);
			break;
		case 3:
			std::cout << "Input account code to search" << std::endl;
			std::cin >> temp_int;
			D.search_account_code(temp_int);
			break;
		case 4:
			std::cout << "Input account owner's surname to search" << std::endl;
			std::cin >> temp_str;
			D.search_account_surname(temp_str);
			break;
		case 5:
			std::cout << "Input full account to search" << std::endl;
			std::cin >> acc1;
			D.search_account(acc1);
			break;
		case 6:
			std::cout << "Input account to delete" << std::endl;
			std::cin >> acc1;
			D.delete_account(acc1);
			break;
		case 7:
			std::cout << "Input account to change" << std::endl;
			std::cin >> acc1;
			std::cout << "Input account to insert" << std::endl;
			std::cin >> acc2;
			D.change_account(acc1, std::move(acc2));
			break;
		case 8:
			D.load_out_txt();
			break;
		case 9:
			is_running = false;
			break;
		default:
			std::cout << "invalid option" << std::endl;
			break;
		}

	}
	return 1;
}
#endif // HW_PART_2

