#pragma once
#include <iostream>
#include <string>
#include <map>
#include <algorithm>



struct account {
	unsigned int number;
	unsigned int code;
	char surname[50] = "";
	char creation_date[50] = "";
	double money;
	double annual_percentage;
	account() = default;
	account(unsigned int p_number, unsigned int p_code, const char* p_surname, double p_money, const char* p_creation_date, double p_annual_percentage) {
		number = p_number;
		code = p_code;
		strcpy_s(surname, p_surname);
		strcpy_s(creation_date, p_creation_date);
		money = p_money;
		annual_percentage = p_annual_percentage;
	};

	bool operator == (const account& p) const
	{
		return (number == p.number && code == p.code && strcmp(surname, p.surname) == 0 && money == p.money && strcmp(creation_date, p.creation_date) == 0 && annual_percentage == p.annual_percentage);
	}
	friend std::ostream& operator <<(std::ostream& out, const account& p_acc);
	friend std::istream& operator >>(std::istream& in, account& p_acc);

};



class general
{
private:
	std::map<size_t, account> accounts_map;
	size_t s;

	void load_in();
	void load_out();

public:
	general();
	~general();
	void add_account(account& p);
	bool search_account(const account& p);
	bool search_account_number(const int p);
	bool search_account_code(const int p);
	bool search_account_surname(const std::string& p);
	bool delete_account(const account& p);
	bool change_account(const account& p1, const account& p2);
	void load_out_txt();
};